Index: trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1230)
@@ -807,248 +1524,131 @@
     /// \param rhs the function to apply
     /// \param combining_stub a function which defines which binary operation to use.
-    /// \return a new interpolating_function  with the same mappings for x and y
-	interpolating_function <float_type> & binary_operator(const c2_function<float_type> &rhs,
-           c2_binary_function<float_type> *combining_stub
+    /// \return a new interpolating_function_p  with the same mappings for x and y
+	interpolating_function_p <float_type> & binary_operator(const c2_function<float_type> &rhs,
+           const c2_binary_function<float_type> *combining_stub
            ) const;
-	
-	// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	// can be upcast back to a c2_function to produce unprocessed binaries.
-
-	/// \brief produce a newly resampled interpolating_function  which is the specified sum.
+	/// \brief produce a newly resampled interpolating_function_p  which is the specified sum.
     /// \param rhs the function to add, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-    interpolating_function <float_type> & operator + (const c2_function<float_type> &rhs) const { 
-		return binary_operator(rhs, new c2_sum<float_type>()); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified difference.
+    /// \return a new interpolating_function_p 
+    interpolating_function_p <float_type> & add_pointwise (const c2_function<float_type> &rhs) const { 
+		return binary_operator(rhs, new c2_sum_p<float_type>()); }
+	/// \brief produce a newly resampled interpolating_function_p  which is the specified difference.
     /// \param rhs the function to subtract, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator - (const c2_function<float_type> &rhs) const {
-		return binary_operator(rhs, new c2_diff<float_type>()); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified product.
+    /// \return a new interpolating_function_p 
+	interpolating_function_p <float_type> & subtract_pointwise (const c2_function<float_type> &rhs) const {
+		return binary_operator(rhs, new c2_diff_p<float_type>()); }
+	/// \brief produce a newly resampled interpolating_function_p  which is the specified product.
     /// \param rhs the function to multiply, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator * (const c2_function<float_type> &rhs) const { 
-		return binary_operator(rhs, new c2_product<float_type>()); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified ratio.
+    /// \return a new interpolating_function_p 
+	interpolating_function_p <float_type> & multiply_pointwise (const c2_function<float_type> &rhs) const { 
+		return binary_operator(rhs, new c2_product_p<float_type>()); }
+	/// \brief produce a newly resampled interpolating_function_p  which is the specified ratio.
     /// \param rhs the function to divide, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator / (const c2_function<float_type> &rhs) const { 
-		return binary_operator(rhs, new c2_ratio<float_type>()); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified sum.
-    /// \param rhs a constant to add, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator + (float_type rhs) const { return (*this)+c2_constant<float_type>(rhs); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified difference.
-    /// \param rhs a constant to subtract, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator - (float_type rhs) const { return (*this)-c2_constant<float_type>(rhs); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified product.
-    /// \param rhs a constant to multiply, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator * (float_type rhs) const { return (*this)*c2_constant<float_type>(rhs); }
-	/// \brief produce a newly resampled interpolating_function  which is the specified ratio.
-    /// \param rhs a constant to divide, pointwise
-    /// \return a new interpolating_function 
-    /// \note
-	/// InterpolatingFunctions override the c2_function operators, since they explicitly re-generate the interpolation table
-	/// when they are applied.  If this is not desired, these operators are not virtual, so the interpolating_function 
-	/// can be upcast back to a c2_function to produce unprocessed binaries.
-	interpolating_function <float_type> & operator / (float_type rhs) const { return (*this)/c2_constant<float_type>(rhs); }
-        
-	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception);
-	
-	/// \brief move value & derivatives into our internal coordinates (use splint to go the other way!)
-    /// \note why?
-	void localize_derivatives(float_type xraw, float_type y, float_type yprime, float_type yprime2, float_type *y0, float_type *yp0, float_type *ypp0) const;
-	
-protected:
-		
-	interpolating_function() : c2_function<float_type>() { } // default constructor is never used, prevent accidents by protecting it.
-    
-    /// \brief do the dirty work of constructing the spline.  See interpolating_function  constructor for details.
-	void init(const std::vector<float_type> &, const std::vector<float_type> &, 
+    /// \return a new interpolating_function_p 
+	interpolating_function_p <float_type> & divide_pointwise (const c2_function<float_type> &rhs) const { 
+		return binary_operator(rhs, new c2_ratio_p<float_type>()); }
+    /// \brief copy data from another interpolating function.  This only makes sense if the source
+	/// function has the same transforms as the destination.
+    /// \param rhs interpolating_function_p  to copy from
+	void clone_data(const interpolating_function_p <float_type> &rhs) {
+		Xraw=rhs.Xraw; X=rhs.X; F=rhs.F; y2=rhs.y2;
+		set_sampling_grid_pointer(Xraw);
+	}
+
+	const c2_function_transformation<float_type> &fTransform;
+	
+protected:    
+    /// \brief create the spline coefficients
+	void spline(
 			  bool lowerSlopeNatural, float_type lowerSlope, 
-			  bool upperSlopeNatural, float_type upperSlope,
-			  float_type (*inputXConversion)(float_type)=0, 
-			  float_type (*inputXConversionPrime)(float_type)=0, 
-			  float_type (*inputXConversionDPrime)(float_type)=0, 
-			  float_type (*inputYConversion)(float_type)=0, 
-			  float_type (*inputYConversionPrime)(float_type)=0, 
-			  float_type (*inputYConversionDPrime)(float_type)=0, 
-			  float_type (*outputYConversion)(float_type)=0
-			  ) throw(c2_exception) ;
+			  bool upperSlopeNatural, float_type upperSlope
+			  ) throw(c2_exception);
+
+	// This is for sorting the data. It must be static if it's going to be a class member.
+	static bool comp_pair(std::pair<float_type,float_type> const &i, std::pair<float_type,float_type> const &j) {return i.first<j.first;}
 
     std::vector<float_type> Xraw, X, F, y2;
-	
-	float_type (*fXin)(float_type), (*fYin)(float_type), (*fYout)(float_type);
-	float_type (*fXinPrime)(float_type), (*fYinPrime)(float_type);
-	float_type (*fXinDPrime)(float_type), (*fYinDPrime)(float_type);
-	
-	int xInverted;
-    mutable int lastKLow;
-};
-
-/// \brief An interpolatingFunction with X transformed into log space.  
-///
+	c2_const_ptr<float_type> sampler_function;
+	bool xInverted;
+    mutable size_t lastKLow;
+};
+
+/// \brief A spline with X transformed into log space.  
+/// \ingroup interpolators
 /// Most useful for functions looking like y=log(x) or any other function with a huge X dynamic range,
 /// and a slowly varying Y.
-template <typename float_type=double> class log_lin_interpolating_function : public interpolating_function <float_type> {
-public:
-    /// \brief Construct the function.
-    /// \param x the list of abscissas.  Must be either strictly increasing or strictly decreasing.
-	/// Strictly increasing is preferred, as less memory is used since a copy is not required for the sampling grid.
-    /// \param f the list of function values.
-    /// \param lowerSlopeNatural if true, set y''(first point)=0 in LogLin space, otherwise compute it from \a lowerSope
-    /// \param lowerSlope derivative of the function at the lower bound, used only if \a lowerSlopeNatural is false
-    /// \param upperSlopeNatural if true, set y''(last point)=0 in LogLin space, otherwise compute it from \a upperSope
-    /// \param upperSlope derivative of the function at the upper bound, used only if \a upperSlopeNatural is false
-    log_lin_interpolating_function(const std::vector<float_type> &x, const std::vector<float_type> &f, 
-								bool lowerSlopeNatural=true, float_type lowerSlope=0.0, 
-								bool upperSlopeNatural=true, float_type upperSlope=0.0);
-protected:
-	log_lin_interpolating_function() {} // do not allow naked construction... it is usually an accident.
-};
-
-
-/// \brief An interpolatingFunction with Y transformed into log space.  
-///
+///
+///	The factory function c2_factory::log_lin_interpolating_function() creates *new log_lin_interpolating_function_p()
+template <typename float_type=double> class log_lin_interpolating_function_p : public interpolating_function_p <float_type> {
+public:
+    /// \brief an empty log-linear cubic-spline interpolating_function_p
+    ///
+	log_lin_interpolating_function_p() : interpolating_function_p<float_type>(*new c2_log_lin_function_transformation<float_type>)
+		{ }
+	/// \brief create a new, empty interpolating function of this type (virtual constructor)
+	virtual interpolating_function_p<float_type> &clone() const throw(c2_exception)
+		{	return *new log_lin_interpolating_function_p<float_type>(); }
+};
+
+
+/// \brief A spline with Y transformed into log space.  
+/// \ingroup interpolators
 /// Most useful for functions looking like y=exp(x)
-template <typename float_type=double> class lin_log_interpolating_function : public interpolating_function <float_type> {
-public:
-    /// \brief Construct the function.
-    /// \param x the list of abscissas.  Must be either strictly increasing or strictly decreasing.
-	/// Strictly increasing is preferred, as less memory is used since a copy is not required for the sampling grid.
-    /// \param f the list of function values.
-    /// \param lowerSlopeNatural if true, set y''(first point)=0 in LinLog space, otherwise compute it from \a lowerSope
-    /// \param lowerSlope derivative of the function at the lower bound, used only if \a lowerSlopeNatural is false
-    /// \param upperSlopeNatural if true, set y''(last point)=0 in LinLog space, otherwise compute it from \a upperSope
-    /// \param upperSlope derivative of the function at the upper bound, used only if \a upperSlopeNatural is false
-    lin_log_interpolating_function(const std::vector<float_type> &x, const std::vector<float_type> &f, 
-								bool lowerSlopeNatural=true, float_type lowerSlope=0.0, 
-								bool upperSlopeNatural=true, float_type upperSlope=0.0);
-protected:
-	lin_log_interpolating_function() {} // do not allow naked construction... it is usually an accident.
-};
-
-
-/// \brief An interpolatingFunction with X and Y transformed into log space.  
-///
+///
+///	The factory function c2_factory::lin_log_interpolating_function() creates *new lin_log_interpolating_function_p()
+template <typename float_type=double> class lin_log_interpolating_function_p : public interpolating_function_p <float_type> {
+public:
+    /// \brief an empty linear-log cubic-spline interpolating_function_p
+    ///
+	lin_log_interpolating_function_p() : interpolating_function_p<float_type>(*new c2_lin_log_function_transformation<float_type>)
+		{ } 
+	/// \brief create a new, empty interpolating function of this type (virtual constructor)
+	virtual interpolating_function_p<float_type> &clone() const throw(c2_exception)
+		{	return *new lin_log_interpolating_function_p<float_type>(); }
+};
+
+
+/// \brief A spline with X and Y transformed into log space.  
+/// \ingroup interpolators
 /// Most useful for functions looking like y=x^n or any other function with a huge X and Y dynamic range.
-template <typename float_type=double> class log_log_interpolating_function : public interpolating_function <float_type> {
-public:
-    /// \brief Construct the function.
-    /// \param x the list of abscissas.  Must be either strictly increasing or strictly decreasing.
-	/// Strictly increasing is preferred, as less memory is used since a copy is not required for the sampling grid.
-    /// \param f the list of function values.
-    /// \param lowerSlopeNatural if true, set y''(first point)=0 in LogLog space, otherwise compute it from \a lowerSope
-    /// \param lowerSlope derivative of the function at the lower bound, used only if \a lowerSlopeNatural is false
-    /// \param upperSlopeNatural if true, set y''(last point)=0 in LogLog space, otherwise compute it from \a upperSope
-    /// \param upperSlope derivative of the function at the upper bound, used only if \a upperSlopeNatural is false
-    log_log_interpolating_function(const std::vector<float_type> &x, const std::vector<float_type> &f, 
-								bool lowerSlopeNatural=true, float_type lowerSlope=0.0, 
-								bool upperSlopeNatural=true, float_type upperSlope=0.0);
-protected:
-	log_log_interpolating_function() {} // do not allow naked construction... it is usually an accident.
-};
-
-
-/// \brief An interpolating_function  with X in reciprocal space and Y transformed in log space.  
-///
+///
+///	The factory function c2_factory::log_log_interpolating_function() creates *new log_log_interpolating_function_p()
+template <typename float_type=double> class log_log_interpolating_function_p : public interpolating_function_p <float_type> {
+public:	
+    /// \brief an empty log-log cubic-spline interpolating_function_p
+    ///
+	log_log_interpolating_function_p() : interpolating_function_p<float_type>(*new c2_log_log_function_transformation<float_type>)
+		{ } 
+	/// \brief create a new, empty interpolating function of this type (virtual constructor)
+	virtual interpolating_function_p<float_type> &clone() const throw(c2_exception)
+	{	return *new log_log_interpolating_function_p<float_type>(); }
+};
+
+
+/// \brief A spline with X in reciprocal space and Y transformed in log space.  
+/// \ingroup interpolators
 /// Most useful for thermodynamic types of data where Y is roughly A*exp(-B/x). 
 /// Typical examples are reaction rate data, and thermistor calibration data.
-template <typename float_type=double> class arrhenius_interpolating_function : public interpolating_function <float_type> {
-public:
-    /// \brief Construct the function.
-    /// \param x the list of abscissas.  Must be either strictly increasing or strictly decreasing.
-	/// Strictly increasing is preferred, as less memory is used since a copy is not required for the sampling grid.
-    /// \param f the list of function values.
-    /// \param lowerSlopeNatural if true, set y''(first point)=0 in Arrhenius space, otherwise compute it from \a lowerSope
-    /// \param lowerSlope derivative of the function at the lower bound, used only if \a lowerSlopeNatural is false
-    /// \param upperSlopeNatural if true, set y''(last point)=0 in Arrhenius space, otherwise compute it from \a upperSope
-    /// \param upperSlope derivative of the function at the upper bound, used only if \a upperSlopeNatural is false
-    arrhenius_interpolating_function(const std::vector<float_type> &x, const std::vector<float_type> &f, 
-								bool lowerSlopeNatural=true, float_type lowerSlope=0.0, 
-								bool upperSlopeNatural=true, float_type upperSlope=0.0);
-protected:
-	arrhenius_interpolating_function() {} // do not allow naked construction... it is usually an accident.
-};
-
-/**
- \brief create a linear-linear interpolating grid with both x & y set to 
- (xmin, xmin+dx, ... xmin + (count-1)*dx )
-
- very useful for transformaiton with other functions e.g. 
- \code
- f=c2_sin<double>::sin(LinearInterpolatingGrid(-0.1,0.1, 65)) 
- \endcode
- creates a spline table of sin(x) slightly beyond the first period
- \param xmin the starting point for the grid
- \param dx the step size for the grid
- \param count the number of points in the  grid
- \return an identity interpolating_function  with the requested grid 
- */
-template <typename float_type> interpolating_function <float_type> &linear_interpolating_grid(float_type xmin, float_type dx, int count) {
-	std::vector<float_type> x(count);
-	for(int i=0; i<count; i++) x[i]=xmin + i * dx;
-	return *new interpolating_function <float_type>(x,x);
-}
-
-/**
- \brief create a log-log interpolating grid with both x & y set to 
- (xmin, xmin*dx, ... xmin * dx^(count-1) )
-
- very useful for transformaiton with other functions e.g. 
- \code
- f=c2_log<double>::log(LogLogInterpolatingGrid(2, 1.1, 65)) 
- \endcode
- creates a spline table of log(x)
- \param xmin the starting point for the grid
- \param dx the ratio between points
- \param count the number of points in the  grid
- \return an identity log_log_interpolating_function with the requested grid 
-*/
-template <typename float_type> log_log_interpolating_function <float_type> &log_log_interpolating_grid(float_type xmin, float_type dx, int count) {
-	std::vector<float_type> x(count);
-	x[0]=xmin;
-	for(int i=1; i<count; i++) x[i]=dx*x[i-1];
-	return *new log_log_interpolating_function<float_type>(x,x);
-}
+///
+///	The factory function c2_factory::arrhenius_interpolating_function() creates *new arrhenius_interpolating_function_p()
+template <typename float_type=double> class arrhenius_interpolating_function_p : public interpolating_function_p <float_type> {
+public:
+    /// \brief an empty arrhenius cubic-spline interpolating_function_p
+    ///
+	arrhenius_interpolating_function_p() : interpolating_function_p<float_type>(*new c2_arrhenius_function_transformation<float_type>)
+		{ } 
+	/// \brief create a new, empty interpolating function of this type (virtual constructor)
+	virtual interpolating_function_p<float_type> &clone() const throw(c2_exception)
+	{	return *new arrhenius_interpolating_function_p<float_type>(); }	
+};
 
 /// \brief compute sin(x) with its derivatives.
-///
-/// Creates a singleton instance c2_sin::sin of itself for convenient access.
-template <typename float_type=double> class c2_sin : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is alread a singleton c2_sin::sin, which usually suffices.
-	c2_sin() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::sin() creates *new c2_sin_p
+template <typename float_type=double> class c2_sin_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_sin_p() : c2_function<float_type>() {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
@@ -1058,29 +1658,29 @@
     /// \param xmin the lower bound for the grid
     /// \param xmax upper bound for the grid
-    /// \return a new sampling grid.
-	virtual std::vector<float_type> &get_sampling_grid(float_type xmin, float_type xmax); 
-    /// \brief the static singleton 
-	static const c2_sin sin;
-};
+    /// \param [in, out] grid the sampling grid.
+	virtual void get_sampling_grid(float_type xmin, float_type xmax,  std::vector<float_type> &grid) const; 
+};
+
 /// \brief compute cos(x) with its derivatives.
-///
-/// Creates a singleton instance c2_cos::cos of itself for convenient access.
-template <typename float_type=double> class c2_cos : public c2_sin<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_cos::cos, which usually suffices.
-	c2_cos() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::cos() creates *new c2_cos_p
+template <typename float_type=double> class c2_cos_p : public c2_sin_p<float_type> {
+public:
+	/// \brief constructor.
+	c2_cos_p() : c2_sin_p<float_type>() {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
 	{ float_type q=std::cos(x); if(yprime) *yprime=-std::sin(x); if(yprime2) *yprime2=-q; return q; }	
-    /// \brief the static singleton 
-	static const c2_cos cos;
-};
+};
+
 /// \brief compute tan(x) with its derivatives.
-///
-/// Creates a singleton instance c2_tan::tan of itself for convenient access.
-template <typename float_type=double> class c2_tan : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_tan::tan, which usually suffices.
-	c2_tan() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::tan() creates *new c2_tan_p
+template <typename float_type=double> class c2_tan_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_tan_p() : c2_function<float_type>() {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
@@ -1092,53 +1692,53 @@
 		return t; 
 	}	
-    /// \brief the static singleton 
-	static const c2_tan tan;
-};
+};
+
 /// \brief compute log(x) with its derivatives.
-///
-/// Creates a singleton instance c2_log::log of itself for convenient access.
-template <typename float_type=double> class c2_log : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_log::log, which usually suffices.
-	c2_log() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::log() creates *new c2_log_p
+template <typename float_type=double> class c2_log_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_log_p() : c2_function<float_type>() {}
 
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
 	{ if(yprime) *yprime=1.0/x; if(yprime2) *yprime2=-1.0/(x*x); return std::log(x); }	
-    /// \brief the static singleton 
-	static const c2_log log;
-};
+};
+
 /// \brief compute exp(x) with its derivatives.
-///
-/// Creates a singleton instance c2_exp::exp of itself for convenient access.
-template <typename float_type=double>  class c2_exp : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_exp::exp, which usually suffices.
-	c2_exp() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::exp() creates *new c2_exp_p
+template <typename float_type=double>  class c2_exp_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_exp_p() : c2_function<float_type>() {}
 
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
 	{ float_type q=std::exp(x); if(yprime) *yprime=q; if(yprime2) *yprime2=q; return q; }
-    /// \ brief the static singleton 
-	static const c2_exp exp;
-};
+};
+
 /// \brief compute sqrt(x) with its derivatives.
-///
-/// Creates a singleton instance c2_sqrt::sqrt of itself for convenient access.
-template <typename float_type=double> class c2_sqrt : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_sqrt::sqrt, which usually suffices.
-	c2_sqrt() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::sqrt() creates *new c2_sqrt_p()
+template <typename float_type=double> class c2_sqrt_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_sqrt_p() : c2_function<float_type>() {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
 	{ float_type q=std::sqrt(x); if(yprime) *yprime=0.5/q; if(yprime2) *yprime2=-0.25/(x*q); return q; }
-    /// \brief the static singleton 
-	static const c2_sqrt sqrt;
-};
+};
+
 /// \brief compute scale/x with its derivatives.
-///
-/// Creates a singleton instance c2_recip:recip of itself for convenient access.
-template <typename float_type=double> class c2_recip : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_recip::recip, which usually suffices.
-	c2_recip(float_type scale) : rscale(scale) {}
+/// \ingroup parametric_functions
+///
+/// The factory function c2_factory::recip() creates *new c2_recip_p
+template <typename float_type=double> class c2_recip_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_recip_p(float_type scale) : c2_function<float_type>(), rscale(scale) {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
@@ -1153,34 +1753,33 @@
 	/// \param scale the new numerator
 	void reset(float_type scale) { rscale=scale; } 
-    /// \brief the static singleton 
-	static const c2_recip recip;
 private:
 	float_type rscale;
 };
+
 /// \brief compute x with its derivatives.
-///
-/// Creates a singleton instance c2_identity::identity of itself for convenient access.
-template <typename float_type=double> class c2_identity : public c2_function<float_type> {
-public:
-	/// \brief constructor.  There is already a singleton c2_identity::identity, which usually suffices.
-	c2_identity() {}
+/// \ingroup math_functions
+///
+/// The factory function c2_factory::identity() creates *new c2_identity_p
+template <typename float_type=double> class c2_identity_p : public c2_function<float_type> {
+public:
+	/// \brief constructor.
+	c2_identity_p() : c2_function<float_type>() {}
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception)
 	{ if(yprime) *yprime=1.0; if(yprime2) *yprime2=0; return x; }
-    /// \brief the static singleton 
-	static const c2_identity identity;
 };
 
 /**
  \brief create a linear mapping of another function 
- 
+ \ingroup parametric_functions
  for example, given a c2_function \a f 
  \code 
- c2_linear<double> L(1.2, 2.0, 3.0);
- c2_composed_function<double> &F=L(f); 
+ c2_function<double> &F=c2_linear<double>(1.2, 2.0, 3.0)(f);
  \endcode
  produces a new c2_function F=2.0+3.0*(\a f - 1.2) 
+ 
+ The factory function c2_factory::linear() creates *new c2_linear_p
 */
-template <typename float_type=double> class c2_linear : public c2_function<float_type> {
+template <typename float_type=double> class c2_linear_p : public c2_function<float_type> {
 public:
     /// \brief Construct the operator f=y0 + slope * (x-x0)
@@ -1188,5 +1787,6 @@
     /// \param y0 the y-intercept i.e. f(x0)
     /// \param slope the slope of the mapping
-	c2_linear(float_type x0, float_type y0, float_type slope) : xint(x0), intercept(y0), m(slope) {}
+	c2_linear_p(float_type x0, float_type y0, float_type slope) : 
+		c2_function<float_type>(), xint(x0), intercept(y0), m(slope) {}
     /// \brief Change the slope and intercepts after construction.
 	/// \param x0 the x offset
@@ -1200,14 +1800,13 @@
 		float_type xint, intercept, m;
 protected:
-		c2_linear() {} // do not allow naked construction... it is usually an accident.
+		c2_linear_p() {} // do not allow naked construction... it is usually an accident.
 };
 
 /**
 \brief create a quadratic mapping of another function 
- 
+ \ingroup parametric_functions
  for example, given a c2_function \a f 
  \code 
- c2_quadratic<double> Q(1.2, 2.0, 3.0, 4.0);
- c2_composed_function<double> &F=Q(f); 
+ c2_function<double> &F=c2_quadratic<double>(1.2, 2.0, 3.0, 4.0)(f);
  \endcode
  produces a new c2_function F=2.0 + 3.0*(f-1.2) + 4.0*(f-1.2)^2 
@@ -1215,6 +1814,7 @@
  note that the parameters are overdetermined, but allows the flexibility of two different representations
 
+ The factory function c2_factory::quadratic() creates *new c2_quadratic_p
  */
-template <typename float_type=double> class c2_quadratic : public c2_function<float_type> {
+template <typename float_type=double> class c2_quadratic_p : public c2_function<float_type> {
 public:
     /// \brief Construct the operator
@@ -1223,6 +1823,7 @@
     /// \param xcoef the scale on the (\a x - \a x0) term
     /// \param x2coef the scale on the (\a x - \a x0)^2 term
-	c2_quadratic(float_type x0, float_type y0, float_type xcoef, float_type x2coef) : intercept(y0), center(x0), a(x2coef), b(xcoef) {}
-    /// Modify the mapping after construction
+	c2_quadratic_p(float_type x0, float_type y0, float_type xcoef, float_type x2coef) : 
+		c2_function<float_type>(), intercept(y0), center(x0), a(x2coef), b(xcoef) {}
+    /// \brief Modify the coefficients after construction
     /// \param x0 the new center around which the powers are computed
     /// \param y0 the new value of the function at \a x = \a x0
